unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Forms, Controls, IniFiles, SysUtils, Graphics, ExtCtrls, StdCtrls, Dialogs, Classes, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    lblHeight: TLabel;
    lblLeft: TLabel;
    lblRestoredHeight: TLabel;
    lblRestoredLeft: TLabel;
    lblRestoredTop: TLabel;
    lblRestoredWidth: TLabel;
    lblTop: TLabel;
    lblWidth: TLabel;
    lblWindowState: TLabel;
    Panel1: TPanel;
    procedure FormChangeBounds(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
var
  Config: TIniFile;
begin
  Config := TIniFile.Create('config.ini');
  try
    Top := Config.ReadInteger('Position', 'Top', 100);
    Left := Config.ReadInteger('Position', 'Left', 100);
    Width := Config.ReadInteger('Position', 'Width', 320);
    Height := Config.ReadInteger('Position', 'Height', 240);
    // ---------------------------------------------------------------------
    // Wenn das Fenster zweimal im Vollbildmodus (wsMaximized) geöffnet wird,
    // gehen die Werte für RestoredLeft, RestoredTop, RestoredWidth
    // und RestoredHeight verloren.
    // Deshalb das Fenster zuerst im Modus wsNormal öffnen und dann erst in
    // den gespeicherten Modus wechseln.

    // If the window is opened twice in full screen mode (wsMaximized),
    // the values for RestoredLeft, RestoredTop, RestoredWidth and
    // RestoredHeight are lost.
    // Therefore open the window first in the wsNormal mode and
    // then switch to the saved mode.
    WindowState := wsNormal;
    Application.ProcessMessages;
    // ---------------------------------------------------------------------
    WindowState := TWindowState(Config.ReadInteger('Position', 'WindowState', 0));
  finally
    Config.Free;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_F11 then
  begin
    if WindowState = wsNormal then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    Key := 0;
  end;
end;

procedure TForm1.FormChangeBounds(Sender: TObject);
begin
  lblWindowState.Caption := 'WindowState: ' + WindowStateToStr(WindowState);

  lblLeft.Caption := 'Left: ' + Left.ToString;
  lblTop.Caption := 'Top: ' + Top.ToString;
  lblWidth.Caption := 'Width: ' + Width.ToString;
  lblHeight.Caption := 'Height: ' + Height.ToString;

  lblRestoredLeft.Caption := 'RestoredLeft: ' + RestoredLeft.ToString;
  lblRestoredTop.Caption := 'RestoredTop: ' + RestoredTop.ToString;
  lblRestoredWidth.Caption := 'RestoredWidth: ' + RestoredWidth.ToString;
  lblRestoredHeight.Caption := 'RestoredHeight: ' + RestoredHeight.ToString;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
  Config: TIniFile;
begin
  if WindowState = wsMinimized then
    WindowState := wsNormal;

  Config := TIniFile.Create('config.ini');
  try
    Config.WriteInteger('Position', 'Top', RestoredTop);
    Config.WriteInteger('Position', 'Left', RestoredLeft);
    Config.WriteInteger('Position', 'Width', RestoredWidth);
    Config.WriteInteger('Position', 'Height', RestoredHeight);
    Config.WriteInteger('Position', 'WindowState', Integer(WindowState));
  except
    ShowMessage('The configuration could not be saved.');
  end;
  Config.Free;
end;

end.
