unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Forms, Controls, IniFiles, SysUtils, Graphics, ExtCtrls, StdCtrls, Dialogs, Classes, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    lblHeight: TLabel;
    lblLeft: TLabel;
    lblRestoredHeight: TLabel;
    lblRestoredLeft: TLabel;
    lblRestoredTop: TLabel;
    lblRestoredWidth: TLabel;
    lblTop: TLabel;
    lblWidth: TLabel;
    lblWindowState: TLabel;
    Panel1: TPanel;
    procedure FormChangeBounds(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  rhsRegUtils;

var
  RegisterPfad: String = 'Software\rhsRegUtilsTest\';

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  Left := ReadRegInteger(RegisterPfad + 'Position', 'Left', (Screen.Width - Constraints.MinWidth) div 2);
  Top := ReadRegInteger(RegisterPfad + 'Position', 'Top', (Screen.Height - Constraints.MinHeight) div 2);
  Width := ReadRegInteger(RegisterPfad + 'Position', 'Width', Constraints.MinWidth);
  Height := ReadRegInteger(RegisterPfad + 'Position', 'Height', Constraints.MinHeight);

  // ---------------------------------------------------------------------
  // Wenn das Fenster zweimal im Vollbildmodus (wsMaximized) geöffnet wird,
  // gehen die Werte für RestoredLeft und RestoredTop verloren.
  // Deshalb das Fenster zuerst im Modus wsNormal öffnen und
  // dann erst in den gespeicherten Modus wechseln.

  // If the window is opened twice in full screen mode (wsMaximized),
  // the values for RestoredLeft and RestoredTop are lost.
  // Therefore open the window first in the wsNormal mode and
  // then switch to the saved mode.
  WindowState := wsNormal;
  Application.ProcessMessages;
  // ---------------------------------------------------------------------
  WindowState := TWindowState(ReadRegInteger(RegisterPfad + 'Position', 'WindowState', 0));
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_F11 then
  begin
    if WindowState = wsNormal then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    Key := 0;
  end;
end;

procedure TForm1.FormChangeBounds(Sender: TObject);
begin
  lblWindowState.Caption := 'WindowState: ' + WindowStateToStr(WindowState);

  lblLeft.Caption := 'Left: ' + Left.ToString;
  lblTop.Caption := 'Top: ' + Top.ToString;
  lblWidth.Caption := 'Width: ' + Width.ToString;
  lblHeight.Caption := 'Height: ' + Height.ToString;

  lblRestoredLeft.Caption := 'RestoredLeft: ' + RestoredLeft.ToString;
  lblRestoredTop.Caption := 'RestoredTop: ' + RestoredTop.ToString;
  lblRestoredWidth.Caption := 'RestoredWidth: ' + RestoredWidth.ToString;
  lblRestoredHeight.Caption := 'RestoredHeight: ' + RestoredHeight.ToString;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if WindowState = wsMinimized then
    WindowState := wsNormal;
  try
    WriteRegInteger(RegisterPfad + 'Position', 'WindowState', Integer(WindowState));
    WriteRegInteger(RegisterPfad + 'Position', 'Left', RestoredLeft);
    WriteRegInteger(RegisterPfad + 'Position', 'Top', RestoredTop);
    WriteRegInteger(RegisterPfad + 'Position', 'Width', RestoredWidth);
    WriteRegInteger(RegisterPfad + 'Position', 'Height', RestoredHeight);
  except
    ShowMessage('The configuration could not be saved.');
  end;
end;

end.
